xmltooling 3.0.4

Public Member Functions | List of all members
xmltooling::ConcreteXMLObjectBuilder Class Referenceabstract

A factory interface for obtaining XMLObjects. More...

`#include <xmltooling/ConcreteXMLObjectBuilder.h>`

Inheritance diagram for xmltooling::ConcreteXMLObjectBuilder:
[legend]
Collaboration diagram for xmltooling::ConcreteXMLObjectBuilder:
[legend]

## Public Member Functions
virtual XMLObject * | buildObject () const =0
| Creates an empty XMLObject with a defaulted element name and/or type. More...
virtual XMLObject * | buildObject (const XMLCh *nsURI, const XMLCh *localName, const XMLCh *prefix=0, const QName *schemaType=0) const=0
| Creates an empty XMLObject with a particular element name. More...
Public Member Functions inherited from xmltooling::XMLObjectBuilder
virtual XMLObject * | buildObject (const XMLCh *nsURI, const XMLCh *localName, const XMLCh *prefix=0, const QName *schemaType=0) const =0
| Creates an empty XMLObject with a particular element name. More...
XMLObject * | buildFromQName (const QName &q) const
| Creates an empty XMLObject with a particular element name. More...
XMLObject * | buildFromElement (xercesc::DOMElement *element, bool bindDocument=false) const
| Creates an unmarshalled XMLObject from a DOM Element. More...
XMLObject * | buildFromDocument (xercesc::DOMDocument *doc, bool bindDocument=true) const
| Creates an unmarshalled XMLObject from the root of a DOM Document. More...

## Additional Inherited Members
Static Public Member Functions inherited from xmltooling::XMLObjectBuilder
static XMLObject * | buildOneFromElement (xercesc::DOMElement *element, bool bindDocument=false)
| Creates an unmarshalled XMLObject using the default build method, if a builder can be found. More...
static const XMLObjectBuilder * | getBuilder (const QName &key)
| Retrieves an XMLObjectBuilder using the key it was registered with. More...
static const XMLObjectBuilder * | getBuilder (const xercesc::DOMElement *element)
| Retrieves an XMLObjectBuilder for a given DOM element. More...
static const XMLObjectBuilder * | getDefaultBuilder ()
| Retrieves the default XMLObjectBuilder for DOM elements. More...
static const std::map< QName, XMLObjectBuilder * > & | getBuilders ()
| Gets an immutable list of all the builders currently registered. More...
static void | registerBuilder (const QName &builderKey, XMLObjectBuilder *builder)
| Registers a new builder for the given key. More...
static void | registerDefaultBuilder (XMLObjectBuilder *builder)
| Registers a default builder. More...
static void | deregisterBuilder (const QName &builderKey)
| Deregisters a builder. More...
static void | deregisterDefaultBuilder ()
| Deregisters default builder.
static void | destroyBuilders ()
| Unregisters and destroys all registered builders.

## Detailed Description

A factory interface for obtaining XMLObjects.

Subclasses MAY supply additional factory methods.

## Member Function Documentation

## ◆ buildObject() [1/2]

virtual XMLObject * xmltooling::ConcreteXMLObjectBuilder::buildObject | ( |  | ) | const
| pure virtual

Creates an empty XMLObject with a defaulted element name and/or type.

Returns
  the empty XMLObject

Implemented in xmlsignature::SignatureBuilder.

## ◆ buildObject() [2/2]

virtual XMLObject * xmltooling::XMLObjectBuilder::buildObject | ( | const XMLCh * | nsURI,
|  | const XMLCh * | localName,
|  | const XMLCh * | prefix = `0`,
|  | const QName * | schemaType = `0`
| ) |  | const
| virtual

Creates an empty XMLObject with a particular element name.

The results are undefined if localName is nullptr or empty.

The caller is responsible for freeing the resulting object.

Parameters

  nsURI | namespace URI for element
  localName | local name of element
  prefix | prefix of element name
  schemaType | xsi:type of the object

Returns
  the empty XMLObject

Implements xmltooling::XMLObjectBuilder.

The documentation for this class was generated from the following file:

- xmltooling/ConcreteXMLObjectBuilder.h